<?php

/**

 */
require SYSPATH.'classes/core'.EXT;
require SYSPATH.'classes/rise'.EXT;

spl_autoload_register(array('Rise', 'auto_load'));
ini_set('unserialize_callback_func', 'spl_autoload_call');

I18n::lang('en-us');

Rise::init();

/**
 * Attach the file write to logging. Multiple writers are supported.
 */
Rise::$log->attach(new Log_File(APPPATH.'logs'));

/**
 * Attach a file reader to config. Multiple readers are supported.
 */
Rise::$config->attach(new Config_File);

Rise::modules(array(
    'dune_lib'  => MODPATH.'dune_lib',
    'dune'      => MODPATH.'dune',
));

DefaultDunePluginFw::$plugin_class_name = "Plugin";
DunePluginFw::$instance = new DefaultDunePluginFw();

?>
