<?php

/**
 */
class Welcome extends Screen
{
    public static $plugins_settings;
    
    /**
     * 
     * @param type $arg
     * @return type 
     */
    function input(&$arg)
    {
        if(isset($arg->selected_control_id) && $arg->selected_control_id == 'Welcome->oklic')
        {
            Cookie::set('license', 'yes');

            $arg->selected_media_url = 'Welcome->start';
        } else 
        if(isset($arg->selected_control_id) && $arg->selected_control_id == 'Welcome->nolic')
        {
            return;
            $arg->selected_media_url = '';
        }
             
            
            
        $license = Cookie::get('license', 'no');
        
        if ($license == 'no')
        {
            $defs = array();

            ControlFactory::add_label($defs, " ", '1. Компания Dune HD не несет отвественности за содержимое плагинов.');
            ControlFactory::add_label($defs, " ", '2. Все плагины предоставлены исключительно для ознакомления.');

            ControlFactory::add_label($defs, " ", 'Вы принимаете указанное соглашение?');

            $ok_action = array
                (
                GuiAction::handler_string_id => PLUGIN_HANDLE_USER_INPUT_ACTION_ID,
                GuiAction::data => array(
                    'control_id' => 'Welcome->oklic'
                )
            );

            ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'Welcome->oklic', 'Да', 370, $ok_action);

            $no_action = array
                (
                GuiAction::handler_string_id => PLUGIN_HANDLE_USER_INPUT_ACTION_ID,
                GuiAction::data => array(
                    'selected_media_url' => 'Welcome->nolic'
                )
            );

            ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'Welcome->nolic', 'Нет', 370, $no_action);


            return ActionFactory::show_dialog('ПОЛЬЗОВАТЕЛЬСКОЕ СОГЛАШЕНИЕ', $defs);
        } 
        
        
        if ($arg->selected_media_url == 'Welcome->start')
        {
            // Remove all cookies were being marked for operations.
            foreach (Cookie::$cookie as $k => $v)
            {
                if (strpos($k, '_plugin') > 0)
                {
                    Cookie::delete($k);
                }
            }

            $arg->selected_media_url = 'Welcome->index';
        }

        /* Operations: uninstall, and install */
        if (isset($arg->control_id))
        {
            switch ($arg->control_id)
            {
                case 'Welcome->remove':

                    preg_match_all('/(.\S*)\/(.\S*)/', $arg->selected_media_url, $m_url);

                    $plugin_name = $m_url[2][0];

                    if (!empty($plugin_name))
                    {
                        $plugin_name = urldecode($plugin_name);

                        Cookie::set($plugin_name . '_plugin', 'remove');
                    }

                    return ActionFactory::invalidate_folders(array($arg->parent_media_url), UserInputHandlerRegistry::create_action($this, 'remove_complite'));

                case 'Welcome->install':

                    preg_match_all('/(.\S*)\/(.\S*)/', $arg->selected_media_url, $m_url);

                    $plugin_name = $m_url[2][0];

                    if (!empty($plugin_name))
                    {
                        $plugin_name = urldecode($plugin_name);

                        preg_match_all('/(.\S*)\/(.\S*)/', $arg->selected_control_id, $m_url);

                        Cookie::set($plugin_name . '_plugin', 'install');
                    }

                    return ActionFactory::invalidate_folders(array($arg->parent_media_url), UserInputHandlerRegistry::create_action($this, 'install_complite'));

                    
                case 'Welcome->revers':

                    preg_match_all('/(.\S*)\/(.\S*)/', $arg->selected_media_url, $m_url);

                    $plugin_name = $m_url[2][0];

                    if (!empty($plugin_name))
                    {
                        $plugin_name = urldecode($plugin_name);

                        preg_match_all('/(.\S*)\/(.\S*)/', $arg->selected_control_id, $m_url);

                        
                        if(Cookie::get($plugin_name . '_plugin', 'remove') == 'remove')
                        {
                            $plugins_root_path = str_replace('dpm/', '', DOCROOT);
                            
                            if(!file_exists($plugins_root_path.$plugin_name))
                            {
                                Cookie::set($plugin_name . '_plugin', 'install');
                                $operation = 'install_complite';
                            }
                            else
                            {
                                Cookie::set($plugin_name . '_plugin', 'update');
                                $operation = 'update_complite';
                            }
                        }
                        else
                        {
                            Cookie::set($plugin_name . '_plugin', 'remove');
                            $operation = 'remove_complite';
                        }
                    }

                    return ActionFactory::invalidate_folders(array($arg->parent_media_url), UserInputHandlerRegistry::create_action($this, $operation));
                    
                    
                case 'remove_complite':

                    $defs = array();
                    $reboot_action = array
                        (
                        GuiAction::handler_string_id => PLUGIN_HANDLE_USER_INPUT_ACTION_ID,
                        GuiAction::data => array(
                            'media_url' => 'Welcome->index'
                        )
                    );

                    ControlFactory::add_label($defs, " ", 'После добавления всех плагинов нажмите кнопку');
                    ControlFactory::add_label($defs, " ", '"D" - \'Выполнить операции\'.');
                    ControlFactory::add_label($defs, " ", '');
                    ControlFactory::add_label($defs, " ", 'Приставка перезагрузится автоматически.');

                    ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'Welcome->index', 'Ok', 150, $reboot_action);

                    return ActionFactory::show_dialog('Плагин был добавлен в очередь для удаления.', $defs);

                case 'Welcome->indicating':

                    $indication_arr_current_key = Cookie::get('indication_arr_current_key');
                    $indication_arr = json_decode(Cookie::get('indication_arr'));
                    $indication_descr = json_decode(Cookie::get('indication_descr'));

                    hd_print($indication_arr_current_key);
                    hd_print($indication_arr[$indication_arr_current_key]);
                    hd_print($indication_descr[$indication_arr_current_key]);
                    
                    switch (Cookie::get('installing_step', 0))
                    {
                        case 1:
                            
                            Cookie::set('installing_step', 2);
                            
                            if($indication_arr[$indication_arr_current_key] == 1)
                                $operation = '"'.$indication_descr[$indication_arr_current_key].'" - Конфигурирование установки...';
                            else
                                $operation = '"'.$indication_descr[$indication_arr_current_key].'" - Удаление предыдущей версии...';
                            
                            break;
                        case 2:
                            $operation = '"'.$indication_descr[$indication_arr_current_key].'" - Установка новой версии...';
                            Cookie::set('installing_step', 3);
                            
                            break;
                        case 3:
                            $operation = '"'.$indication_descr[$indication_arr_current_key].'" - Установка успешно завершена';
                            Cookie::set('installing_step', 0);
                            Cookie::set('indication_arr_current_key', $indication_arr_current_key + 1);
                            break;
                        
                        default:
                            $operation = '"'.$indication_descr[$indication_arr_current_key].'" - Загрузка файлов...';
                            Cookie::set('installing_step', 1);
                            break;
                    }

                    
                    $defs = array();
                    ControlFactory::add_vgap($defs, 25);
                    ControlFactory::add_label($defs, "  ", $operation);

                    ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, '', 'Отмена', 300, null);
                    return ActionFactory::show_dialog('Выполняемая операция...', $defs);

                case 'install_complite':

                    $defs = array();
                    $reboot_action = array
                        (
                        GuiAction::handler_string_id => PLUGIN_HANDLE_USER_INPUT_ACTION_ID,
                        GuiAction::data => array(
                            'media_url' => 'Welcome->index'
                        )
                    );

                    ControlFactory::add_label($defs, " ", 'После добавления всех плагинов нажмите кнопку');
                    ControlFactory::add_label($defs, " ", '"D" - \'Выполнить операции\'.');
                    ControlFactory::add_label($defs, " ", '');
                    ControlFactory::add_label($defs, " ", 'Приставка перезагрузится автоматически.');

                    ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'Welcome->index', 'Ok', 150, $reboot_action);

                    return ActionFactory::show_dialog('Плагин был добавлен в очередь для установки.', $defs);

                case 'update_complite':

                    $defs = array();
                    $reboot_action = array
                        (
                        GuiAction::handler_string_id => PLUGIN_HANDLE_USER_INPUT_ACTION_ID,
                        GuiAction::data => array(
                            'media_url' => 'Welcome->index'
                        )
                    );

                    ControlFactory::add_label($defs, " ", 'После добавления всех плагинов нажмите кнопку');
                    ControlFactory::add_label($defs, " ", '"D" - \'Выполнить операции\'.');
                    ControlFactory::add_label($defs, " ", '');
                    ControlFactory::add_label($defs, " ", 'Приставка перезагрузится автоматически.');

                    ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'Welcome->index', 'Ok', 150, $reboot_action);

                    return ActionFactory::show_dialog('Плагин был добавлен в очередь для обновления.', $defs);
                    
                case 'Welcome->submit_operations':

                    Cookie::set('installing_step', 0); // Start indicationg
                    
                    $handle = popen('pgrep pmfdp', 'r');
                    $pid = fread($handle, 2096);
                    hd_print("pgrep pmfdp = $pid");

                    $pid = trim($pid);

                    if (empty($pid))
                    {
                        hd_print('Welcome->submit_operations self::$plugins_settings = ' . json_encode(self::$plugins_settings));

                        $install_cmd = TangoDunePlugin::LD_LIBRARY_PATH . ' ' . DOCROOT . 'pmfdp reboot';

                        hd_print('chmod +x ' . DOCROOT . 'pmfdp');
                        shell_exec('chmod +x ' . DOCROOT . 'pmfdp');

                        $install_operations = 0;
                        $remove_operations = 0;
                        $all_operatioins = 0;

                        $path = str_replace('dpm/', '', DOCROOT);

                        $indication_arr = array();
                        $indication_descr = array();
                        Cookie::set('indication_arr_current_key', 0);
                        
                        foreach (self::$plugins_settings as $k => $plugin)
                        {
                            if ($plugin->title == 'dpm') continue;

                            if ((Cookie::get($plugin->title . '_plugin') == 'install' || 
                                    Cookie::get($plugin->title . '_plugin') == 'update')
                                    && !empty($path))
                            {
                                array_push($indication_arr, (Cookie::get($plugin->title . '_plugin') == 'install' ? 1 : 2));
                                array_push($indication_descr, strval($plugin->caption));
                                
                                $install_cmd .= ' ' . $plugin->stabile->url . ' ' . $path . $plugin->title . '/ ' . $plugin->stabile->md5;

                                $cmd = 'mkdir ' . $path . $plugin->title . '/';
                                hd_print($cmd);
                                shell_exec($cmd);
                                
                                $install_operations++;
                                $all_operatioins++;
                            } elseif (Cookie::get($plugin->title . '_plugin') == 'remove' && !empty($path))
                            {
                                $cmd = 'rm -r ' . $path . $plugin->title;
                                hd_print($cmd);
                                shell_exec($cmd);

                                $remove_operations++;
                                $all_operatioins++;
                            }

                            Cookie::delete($plugin->title . '_plugin'); // Clean cookie.
                        }
                        echo "======";
                        echo json_encode($indication_arr);
                        Cookie::set('indication_arr', json_encode($indication_arr));
                        
                        echo 'indication_descr' . json_encode($indication_descr);
                        Cookie::set('indication_descr', json_encode($indication_descr));

                        if ($install_operations == 0 && $remove_operations > 0)
                        {
                            $cmd = 'killall shell';
                            hd_print($cmd);
                            shell_exec($cmd);

                            return;
                        }

                        if ($install_operations > 0)
                        {
                            hd_print("\$install_cmd = $install_cmd");
                            shell_exec($install_cmd);
                        }

                        if ($all_operatioins > 0)
                        {
                            return;
                        }
                    } else
                    {
                        $defs = array();

                        ControlFactory::add_label($defs, " ", 'Операции всё ещё выполняется.');
                        ControlFactory::add_label($defs, " ", 'Не выключайте приставку,');
                        ControlFactory::add_label($defs, " ", 'она перезагрузится автоматически');

                        ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'Welcome->index', 'Закрыть сообщение', 300, null);

                        return ActionFactory::show_dialog('Выполнение операций установщика...', $defs);
                    }

                case 'Setup->settings':
                    return Action::open_folder($arg->control_id);
            }
        }

        return Action::open_folder($arg->selected_media_url);
    }

    /**
     * It will be called after was canceled update. 
     * @return type 
     */
    function start()
    {
        return $this->index();
    }
    
    /**
     *
     * @return type 
     */
    function index()
    {
        $language = Cookie::get('language', 'russian');
        
        $curl = curl_init();
        
        $url = sprintf('http://dune-club.info/firmware/%s/dci.xml', $language);
        hd_print($url);
        
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_COOKIESESSION, TRUE);
        curl_setopt($curl, CURLOPT_COOKIEFILE, "cookiefile");
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($curl, CURLOPT_ENCODING, 'gzip,deflate');
        curl_setopt($curl, CURLOPT_USERAGENT, 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/535.11 (KHTML, like Gecko) Chrome/17.0.963.56 Safari/535.11');

        $content = curl_exec($curl);
        curl_close($curl);
        
        try
        {
            self::$plugins_settings = new SimpleXMLElement($content);
        } catch (Exception $e) {}        
        
        $items = array();
        
        $plugins_root_path = str_replace('dpm/', '', DOCROOT);

        foreach (self::$plugins_settings as $plugin)
        {
            if ($plugin->title == 'dpm') continue;

            $is_installed = ').';
            if (file_exists($plugins_root_path . $plugin->title))
            {
                $defined = false;
                
                // for old versions.
                $path = $plugins_root_path . $plugin->title . '/application/classes/upgrader.php';
                if(!is_file($path)) // New versions will be so on.
                    $path = $plugins_root_path . $plugin->title . '/modules/dune/classes/tangoduneplugin.php';
                
                hd_print(sprintf('%s%s/VERSION',$plugins_root_path, $plugin->title));
                
                if(is_file(sprintf('%s%s/VERSION',$plugins_root_path, $plugin->title))) // for all plugins
                {
                        $handle = fopen(sprintf('%s%s/VERSION',$plugins_root_path, $plugin->title), "r");
                         
                        $version_name =  explode('=', fgets($handle));
                        $version_date = explode('=', fgets($handle));
                         
                        fclose($handle);
                        
                        if(isset($version_name[1]) && isset($version_date[1]))
                        {
                            $is_installed = '. Установлена [' . str_replace("\n", '', $version_name[1]) . '  ' . str_replace("\n", '', $version_date[1]) . '] версия).';
                            
                            $defined = true;
                        }
                        
                }
                elseif (is_file($path)) // for old versions. 
                {
                    $handle = fopen($path, "r");
                    $content = fread($handle, filesize($path));

                    fclose($handle);

                    preg_match('/CURRENT_PLUGIN_VERSION_TITLE = \'(.\S*)\'/', $content, $version);
                    $version_name = $version[1];
                    preg_match('/CURRENT_PLUGIN_VERSION_DATE = \'(.*?)\'/', $content, $version);
                    $version_date = $version[1];

                    $is_installed = '. Установлена [' . $version_name . '  ' . $version_date . '] версия).';
                    $defined = true;
                } 
                
                if(!$defined)
                {
                        $is_installed = '. Установлена [не определена] версия).';    
                }
            }


            $operation = Cookie::get($plugin->title . '_plugin');
            if ($operation == 'install')
            {
                $operation = 'УСТАНОВИТЬ - ';
            } elseif ($operation == 'remove')
            {
                $operation = 'УДАЛИТЬ - ';
            } 
            elseif ($operation == 'update')
            {
                $operation = 'ОБНОВИТЬ - ';
            }
            else
            {
                $operation = ' - ';
            }

            array_push($items, array(
                PluginRegularFolderItem::caption => $operation . $plugin->caption . ' (на сервере [' . $plugin->stabile->name . '  ' . $plugin->stabile->date . ']' . $is_installed,
                PluginRegularFolderItem::view_item_params => array
                    (
                    ViewItemParams::icon_path => 'gui_skin://small_icons/folder.aai',
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_dx => 20,
                    ViewItemParams::icon_dy => -5,
                    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                    ViewItemParams::item_caption_width => 1550
                ),
                PluginRegularFolderItem::media_url => 'Welcome->details/' . urlencode($plugin->title)
                    )
            );
        }

        $elements = array
            (
            PluginRegularFolderRange::total => count($items),
            PluginRegularFolderRange::count => count($items),
            PluginRegularFolderRange::more_items_available => false,
            PluginRegularFolderRange::from_ndx => 0,
            PluginRegularFolderRange::items => $items
        );

        return DuneLists::build_text_list($elements, DuneLists::get_dpkg_map($this));
    }
}


