<?php 

class Cookie
{
    static $cookie;
    
    static function init(&$plugin_cookie)
    {
        self::$cookie = $plugin_cookie;
    }
    
    static function get($key = NULL, $default = NULL)
    {
        if( is_null($key) )
        {
            return self::$cookie;
        }
        return isset(self::$cookie->$key) ? self::$cookie->$key : $default;
    }
    
    static function set($key, $val)
    {
        self::$cookie->$key = $val;
    }
    
    static function delete($key)
    {
        unset(self::$cookie->$key);
    }
    
}
